// Copyright 2023, the Chromium project authors.  Please see the AUTHORS file
// for details. All rights reserved. Use of this source code is governed by a
// BSD-style license that can be found in the LICENSE file.
// Autogenerated from Pigeon (v11.0.1), do not edit directly.
// See also: https://pub.dev/packages/pigeon

package io.flutter.plugins.firebase.storage;

import android.util.Log;
import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import io.flutter.plugin.common.BasicMessageChannel;
import io.flutter.plugin.common.BinaryMessenger;
import io.flutter.plugin.common.MessageCodec;
import io.flutter.plugin.common.StandardMessageCodec;
import java.io.ByteArrayOutputStream;
import java.nio.ByteBuffer;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/** Generated class from Pigeon. */
@SuppressWarnings({"unused", "unchecked", "CodeBlock2Expr", "RedundantSuppression", "serial"})
public class GeneratedAndroidFirebaseStorage {

  /** Error class for passing custom error details to Flutter via a thrown PlatformException. */
  public static class FlutterError extends RuntimeException {

    /** The error code. */
    public final String code;

    /** The error details. Must be a datatype supported by the api codec. */
    public final Object details;

    public FlutterError(@NonNull String code, @Nullable String message, @Nullable Object details) {
      super(message);
      this.code = code;
      this.details = details;
    }
  }

  @NonNull
  protected static ArrayList<Object> wrapError(@NonNull Throwable exception) {
    ArrayList<Object> errorList = new ArrayList<Object>(3);
    if (exception instanceof FlutterError) {
      FlutterError error = (FlutterError) exception;
      errorList.add(error.code);
      errorList.add(error.getMessage());
      errorList.add(error.details);
    } else {
      errorList.add(exception.toString());
      errorList.add(exception.getClass().getSimpleName());
      errorList.add(
          "Cause: " + exception.getCause() + ", Stacktrace: " + Log.getStackTraceString(exception));
    }
    return errorList;
  }

  /** The type of operation that generated the action code from calling [TaskState]. */
  public enum PigeonStorageTaskState {
    /** Indicates the task has been paused by the user. */
    PAUSED(0),
    /** Indicates the task is currently in-progress. */
    RUNNING(1),
    /** Indicates the task has successfully completed. */
    SUCCESS(2),
    /** Indicates the task was canceled. */
    CANCELED(3),
    /** Indicates the task failed with an error. */
    ERROR(4);

    final int index;

    private PigeonStorageTaskState(final int index) {
      this.index = index;
    }
  }

  /** Generated class from Pigeon that represents data sent in messages. */
  public static final class PigeonStorageFirebaseApp {
    private @NonNull String appName;

    public @NonNull String getAppName() {
      return appName;
    }

    public void setAppName(@NonNull String setterArg) {
      if (setterArg == null) {
        throw new IllegalStateException("Nonnull field \"appName\" is null.");
      }
      this.appName = setterArg;
    }

    private @Nullable String tenantId;

    public @Nullable String getTenantId() {
      return tenantId;
    }

    public void setTenantId(@Nullable String setterArg) {
      this.tenantId = setterArg;
    }

    private @NonNull String bucket;

    public @NonNull String getBucket() {
      return bucket;
    }

    public void setBucket(@NonNull String setterArg) {
      if (setterArg == null) {
        throw new IllegalStateException("Nonnull field \"bucket\" is null.");
      }
      this.bucket = setterArg;
    }

    /** Constructor is non-public to enforce null safety; use Builder. */
    PigeonStorageFirebaseApp() {}

    public static final class Builder {

      private @Nullable String appName;

      public @NonNull Builder setAppName(@NonNull String setterArg) {
        this.appName = setterArg;
        return this;
      }

      private @Nullable String tenantId;

      public @NonNull Builder setTenantId(@Nullable String setterArg) {
        this.tenantId = setterArg;
        return this;
      }

      private @Nullable String bucket;

      public @NonNull Builder setBucket(@NonNull String setterArg) {
        this.bucket = setterArg;
        return this;
      }

      public @NonNull PigeonStorageFirebaseApp build() {
        PigeonStorageFirebaseApp pigeonReturn = new PigeonStorageFirebaseApp();
        pigeonReturn.setAppName(appName);
        pigeonReturn.setTenantId(tenantId);
        pigeonReturn.setBucket(bucket);
        return pigeonReturn;
      }
    }

    @NonNull
    public ArrayList<Object> toList() {
      ArrayList<Object> toListResult = new ArrayList<Object>(3);
      toListResult.add(appName);
      toListResult.add(tenantId);
      toListResult.add(bucket);
      return toListResult;
    }

    static @NonNull PigeonStorageFirebaseApp fromList(@NonNull ArrayList<Object> list) {
      PigeonStorageFirebaseApp pigeonResult = new PigeonStorageFirebaseApp();
      Object appName = list.get(0);
      pigeonResult.setAppName((String) appName);
      Object tenantId = list.get(1);
      pigeonResult.setTenantId((String) tenantId);
      Object bucket = list.get(2);
      pigeonResult.setBucket((String) bucket);
      return pigeonResult;
    }
  }

  /** Generated class from Pigeon that represents data sent in messages. */
  public static final class PigeonStorageReference {
    private @NonNull String bucket;

    public @NonNull String getBucket() {
      return bucket;
    }

    public void setBucket(@NonNull String setterArg) {
      if (setterArg == null) {
        throw new IllegalStateException("Nonnull field \"bucket\" is null.");
      }
      this.bucket = setterArg;
    }

    private @NonNull String fullPath;

    public @NonNull String getFullPath() {
      return fullPath;
    }

    public void setFullPath(@NonNull String setterArg) {
      if (setterArg == null) {
        throw new IllegalStateException("Nonnull field \"fullPath\" is null.");
      }
      this.fullPath = setterArg;
    }

    private @NonNull String name;

    public @NonNull String getName() {
      return name;
    }

    public void setName(@NonNull String setterArg) {
      if (setterArg == null) {
        throw new IllegalStateException("Nonnull field \"name\" is null.");
      }
      this.name = setterArg;
    }

    /** Constructor is non-public to enforce null safety; use Builder. */
    PigeonStorageReference() {}

    public static final class Builder {

      private @Nullable String bucket;

      public @NonNull Builder setBucket(@NonNull String setterArg) {
        this.bucket = setterArg;
        return this;
      }

      private @Nullable String fullPath;

      public @NonNull Builder setFullPath(@NonNull String setterArg) {
        this.fullPath = setterArg;
        return this;
      }

      private @Nullable String name;

      public @NonNull Builder setName(@NonNull String setterArg) {
        this.name = setterArg;
        return this;
      }

      public @NonNull PigeonStorageReference build() {
        PigeonStorageReference pigeonReturn = new PigeonStorageReference();
        pigeonReturn.setBucket(bucket);
        pigeonReturn.setFullPath(fullPath);
        pigeonReturn.setName(name);
        return pigeonReturn;
      }
    }

    @NonNull
    public ArrayList<Object> toList() {
      ArrayList<Object> toListResult = new ArrayList<Object>(3);
      toListResult.add(bucket);
      toListResult.add(fullPath);
      toListResult.add(name);
      return toListResult;
    }

    static @NonNull PigeonStorageReference fromList(@NonNull ArrayList<Object> list) {
      PigeonStorageReference pigeonResult = new PigeonStorageReference();
      Object bucket = list.get(0);
      pigeonResult.setBucket((String) bucket);
      Object fullPath = list.get(1);
      pigeonResult.setFullPath((String) fullPath);
      Object name = list.get(2);
      pigeonResult.setName((String) name);
      return pigeonResult;
    }
  }

  /** Generated class from Pigeon that represents data sent in messages. */
  public static final class PigeonFullMetaData {
    private @Nullable Map<String, Object> metadata;

    public @Nullable Map<String, Object> getMetadata() {
      return metadata;
    }

    public void setMetadata(@Nullable Map<String, Object> setterArg) {
      this.metadata = setterArg;
    }

    public static final class Builder {

      private @Nullable Map<String, Object> metadata;

      public @NonNull Builder setMetadata(@Nullable Map<String, Object> setterArg) {
        this.metadata = setterArg;
        return this;
      }

      public @NonNull PigeonFullMetaData build() {
        PigeonFullMetaData pigeonReturn = new PigeonFullMetaData();
        pigeonReturn.setMetadata(metadata);
        return pigeonReturn;
      }
    }

    @NonNull
    public ArrayList<Object> toList() {
      ArrayList<Object> toListResult = new ArrayList<Object>(1);
      toListResult.add(metadata);
      return toListResult;
    }

    static @NonNull PigeonFullMetaData fromList(@NonNull ArrayList<Object> list) {
      PigeonFullMetaData pigeonResult = new PigeonFullMetaData();
      Object metadata = list.get(0);
      pigeonResult.setMetadata((Map<String, Object>) metadata);
      return pigeonResult;
    }
  }

  /** Generated class from Pigeon that represents data sent in messages. */
  public static final class PigeonListOptions {
    /**
     * If set, limits the total number of `prefixes` and `items` to return.
     *
     * <p>The default and maximum maxResults is 1000.
     */
    private @NonNull Long maxResults;

    public @NonNull Long getMaxResults() {
      return maxResults;
    }

    public void setMaxResults(@NonNull Long setterArg) {
      if (setterArg == null) {
        throw new IllegalStateException("Nonnull field \"maxResults\" is null.");
      }
      this.maxResults = setterArg;
    }

    /**
     * The nextPageToken from a previous call to list().
     *
     * <p>If provided, listing is resumed from the previous position.
     */
    private @Nullable String pageToken;

    public @Nullable String getPageToken() {
      return pageToken;
    }

    public void setPageToken(@Nullable String setterArg) {
      this.pageToken = setterArg;
    }

    /** Constructor is non-public to enforce null safety; use Builder. */
    PigeonListOptions() {}

    public static final class Builder {

      private @Nullable Long maxResults;

      public @NonNull Builder setMaxResults(@NonNull Long setterArg) {
        this.maxResults = setterArg;
        return this;
      }

      private @Nullable String pageToken;

      public @NonNull Builder setPageToken(@Nullable String setterArg) {
        this.pageToken = setterArg;
        return this;
      }

      public @NonNull PigeonListOptions build() {
        PigeonListOptions pigeonReturn = new PigeonListOptions();
        pigeonReturn.setMaxResults(maxResults);
        pigeonReturn.setPageToken(pageToken);
        return pigeonReturn;
      }
    }

    @NonNull
    public ArrayList<Object> toList() {
      ArrayList<Object> toListResult = new ArrayList<Object>(2);
      toListResult.add(maxResults);
      toListResult.add(pageToken);
      return toListResult;
    }

    static @NonNull PigeonListOptions fromList(@NonNull ArrayList<Object> list) {
      PigeonListOptions pigeonResult = new PigeonListOptions();
      Object maxResults = list.get(0);
      pigeonResult.setMaxResults(
          (maxResults == null)
              ? null
              : ((maxResults instanceof Integer) ? (Integer) maxResults : (Long) maxResults));
      Object pageToken = list.get(1);
      pigeonResult.setPageToken((String) pageToken);
      return pigeonResult;
    }
  }

  /** Generated class from Pigeon that represents data sent in messages. */
  public static final class PigeonSettableMetadata {
    /**
     * Served as the 'Cache-Control' header on object download.
     *
     * <p>See https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Cache-Control.
     */
    private @Nullable String cacheControl;

    public @Nullable String getCacheControl() {
      return cacheControl;
    }

    public void setCacheControl(@Nullable String setterArg) {
      this.cacheControl = setterArg;
    }

    /**
     * Served as the 'Content-Disposition' header on object download.
     *
     * <p>See https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Content-Disposition.
     */
    private @Nullable String contentDisposition;

    public @Nullable String getContentDisposition() {
      return contentDisposition;
    }

    public void setContentDisposition(@Nullable String setterArg) {
      this.contentDisposition = setterArg;
    }

    /**
     * Served as the 'Content-Encoding' header on object download.
     *
     * <p>See https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Content-Encoding.
     */
    private @Nullable String contentEncoding;

    public @Nullable String getContentEncoding() {
      return contentEncoding;
    }

    public void setContentEncoding(@Nullable String setterArg) {
      this.contentEncoding = setterArg;
    }

    /**
     * Served as the 'Content-Language' header on object download.
     *
     * <p>See https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Content-Language.
     */
    private @Nullable String contentLanguage;

    public @Nullable String getContentLanguage() {
      return contentLanguage;
    }

    public void setContentLanguage(@Nullable String setterArg) {
      this.contentLanguage = setterArg;
    }

    /**
     * Served as the 'Content-Type' header on object download.
     *
     * <p>See https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Content-Type.
     */
    private @Nullable String contentType;

    public @Nullable String getContentType() {
      return contentType;
    }

    public void setContentType(@Nullable String setterArg) {
      this.contentType = setterArg;
    }

    /** Additional user-defined custom metadata. */
    private @Nullable Map<String, String> customMetadata;

    public @Nullable Map<String, String> getCustomMetadata() {
      return customMetadata;
    }

    public void setCustomMetadata(@Nullable Map<String, String> setterArg) {
      this.customMetadata = setterArg;
    }

    public static final class Builder {

      private @Nullable String cacheControl;

      public @NonNull Builder setCacheControl(@Nullable String setterArg) {
        this.cacheControl = setterArg;
        return this;
      }

      private @Nullable String contentDisposition;

      public @NonNull Builder setContentDisposition(@Nullable String setterArg) {
        this.contentDisposition = setterArg;
        return this;
      }

      private @Nullable String contentEncoding;

      public @NonNull Builder setContentEncoding(@Nullable String setterArg) {
        this.contentEncoding = setterArg;
        return this;
      }

      private @Nullable String contentLanguage;

      public @NonNull Builder setContentLanguage(@Nullable String setterArg) {
        this.contentLanguage = setterArg;
        return this;
      }

      private @Nullable String contentType;

      public @NonNull Builder setContentType(@Nullable String setterArg) {
        this.contentType = setterArg;
        return this;
      }

      private @Nullable Map<String, String> customMetadata;

      public @NonNull Builder setCustomMetadata(@Nullable Map<String, String> setterArg) {
        this.customMetadata = setterArg;
        return this;
      }

      public @NonNull PigeonSettableMetadata build() {
        PigeonSettableMetadata pigeonReturn = new PigeonSettableMetadata();
        pigeonReturn.setCacheControl(cacheControl);
        pigeonReturn.setContentDisposition(contentDisposition);
        pigeonReturn.setContentEncoding(contentEncoding);
        pigeonReturn.setContentLanguage(contentLanguage);
        pigeonReturn.setContentType(contentType);
        pigeonReturn.setCustomMetadata(customMetadata);
        return pigeonReturn;
      }
    }

    @NonNull
    public ArrayList<Object> toList() {
      ArrayList<Object> toListResult = new ArrayList<Object>(6);
      toListResult.add(cacheControl);
      toListResult.add(contentDisposition);
      toListResult.add(contentEncoding);
      toListResult.add(contentLanguage);
      toListResult.add(contentType);
      toListResult.add(customMetadata);
      return toListResult;
    }

    static @NonNull PigeonSettableMetadata fromList(@NonNull ArrayList<Object> list) {
      PigeonSettableMetadata pigeonResult = new PigeonSettableMetadata();
      Object cacheControl = list.get(0);
      pigeonResult.setCacheControl((String) cacheControl);
      Object contentDisposition = list.get(1);
      pigeonResult.setContentDisposition((String) contentDisposition);
      Object contentEncoding = list.get(2);
      pigeonResult.setContentEncoding((String) contentEncoding);
      Object contentLanguage = list.get(3);
      pigeonResult.setContentLanguage((String) contentLanguage);
      Object contentType = list.get(4);
      pigeonResult.setContentType((String) contentType);
      Object customMetadata = list.get(5);
      pigeonResult.setCustomMetadata((Map<String, String>) customMetadata);
      return pigeonResult;
    }
  }

  /** Generated class from Pigeon that represents data sent in messages. */
  public static final class PigeonListResult {
    private @NonNull List<PigeonStorageReference> items;

    public @NonNull List<PigeonStorageReference> getItems() {
      return items;
    }

    public void setItems(@NonNull List<PigeonStorageReference> setterArg) {
      if (setterArg == null) {
        throw new IllegalStateException("Nonnull field \"items\" is null.");
      }
      this.items = setterArg;
    }

    private @Nullable String pageToken;

    public @Nullable String getPageToken() {
      return pageToken;
    }

    public void setPageToken(@Nullable String setterArg) {
      this.pageToken = setterArg;
    }

    private @NonNull List<PigeonStorageReference> prefixs;

    public @NonNull List<PigeonStorageReference> getPrefixs() {
      return prefixs;
    }

    public void setPrefixs(@NonNull List<PigeonStorageReference> setterArg) {
      if (setterArg == null) {
        throw new IllegalStateException("Nonnull field \"prefixs\" is null.");
      }
      this.prefixs = setterArg;
    }

    /** Constructor is non-public to enforce null safety; use Builder. */
    PigeonListResult() {}

    public static final class Builder {

      private @Nullable List<PigeonStorageReference> items;

      public @NonNull Builder setItems(@NonNull List<PigeonStorageReference> setterArg) {
        this.items = setterArg;
        return this;
      }

      private @Nullable String pageToken;

      public @NonNull Builder setPageToken(@Nullable String setterArg) {
        this.pageToken = setterArg;
        return this;
      }

      private @Nullable List<PigeonStorageReference> prefixs;

      public @NonNull Builder setPrefixs(@NonNull List<PigeonStorageReference> setterArg) {
        this.prefixs = setterArg;
        return this;
      }

      public @NonNull PigeonListResult build() {
        PigeonListResult pigeonReturn = new PigeonListResult();
        pigeonReturn.setItems(items);
        pigeonReturn.setPageToken(pageToken);
        pigeonReturn.setPrefixs(prefixs);
        return pigeonReturn;
      }
    }

    @NonNull
    public ArrayList<Object> toList() {
      ArrayList<Object> toListResult = new ArrayList<Object>(3);
      toListResult.add(items);
      toListResult.add(pageToken);
      toListResult.add(prefixs);
      return toListResult;
    }

    static @NonNull PigeonListResult fromList(@NonNull ArrayList<Object> list) {
      PigeonListResult pigeonResult = new PigeonListResult();
      Object items = list.get(0);
      pigeonResult.setItems((List<PigeonStorageReference>) items);
      Object pageToken = list.get(1);
      pigeonResult.setPageToken((String) pageToken);
      Object prefixs = list.get(2);
      pigeonResult.setPrefixs((List<PigeonStorageReference>) prefixs);
      return pigeonResult;
    }
  }

  public interface Result<T> {
    @SuppressWarnings("UnknownNullness")
    void success(T result);

    void error(@NonNull Throwable error);
  }

  private static class FirebaseStorageHostApiCodec extends StandardMessageCodec {
    public static final FirebaseStorageHostApiCodec INSTANCE = new FirebaseStorageHostApiCodec();

    private FirebaseStorageHostApiCodec() {}

    @Override
    protected Object readValueOfType(byte type, @NonNull ByteBuffer buffer) {
      switch (type) {
        case (byte) 128:
          return PigeonFullMetaData.fromList((ArrayList<Object>) readValue(buffer));
        case (byte) 129:
          return PigeonListOptions.fromList((ArrayList<Object>) readValue(buffer));
        case (byte) 130:
          return PigeonListResult.fromList((ArrayList<Object>) readValue(buffer));
        case (byte) 131:
          return PigeonSettableMetadata.fromList((ArrayList<Object>) readValue(buffer));
        case (byte) 132:
          return PigeonStorageFirebaseApp.fromList((ArrayList<Object>) readValue(buffer));
        case (byte) 133:
          return PigeonStorageReference.fromList((ArrayList<Object>) readValue(buffer));
        default:
          return super.readValueOfType(type, buffer);
      }
    }

    @Override
    protected void writeValue(@NonNull ByteArrayOutputStream stream, Object value) {
      if (value instanceof PigeonFullMetaData) {
        stream.write(128);
        writeValue(stream, ((PigeonFullMetaData) value).toList());
      } else if (value instanceof PigeonListOptions) {
        stream.write(129);
        writeValue(stream, ((PigeonListOptions) value).toList());
      } else if (value instanceof PigeonListResult) {
        stream.write(130);
        writeValue(stream, ((PigeonListResult) value).toList());
      } else if (value instanceof PigeonSettableMetadata) {
        stream.write(131);
        writeValue(stream, ((PigeonSettableMetadata) value).toList());
      } else if (value instanceof PigeonStorageFirebaseApp) {
        stream.write(132);
        writeValue(stream, ((PigeonStorageFirebaseApp) value).toList());
      } else if (value instanceof PigeonStorageReference) {
        stream.write(133);
        writeValue(stream, ((PigeonStorageReference) value).toList());
      } else {
        super.writeValue(stream, value);
      }
    }
  }

  /** Generated interface from Pigeon that represents a handler of messages from Flutter. */
  public interface FirebaseStorageHostApi {

    void getReferencebyPath(
        @NonNull PigeonStorageFirebaseApp app,
        @NonNull String path,
        @Nullable String bucket,
        @NonNull Result<PigeonStorageReference> result);

    void setMaxOperationRetryTime(
        @NonNull PigeonStorageFirebaseApp app, @NonNull Long time, @NonNull Result<Void> result);

    void setMaxUploadRetryTime(
        @NonNull PigeonStorageFirebaseApp app, @NonNull Long time, @NonNull Result<Void> result);

    void setMaxDownloadRetryTime(
        @NonNull PigeonStorageFirebaseApp app, @NonNull Long time, @NonNull Result<Void> result);

    void useStorageEmulator(
        @NonNull PigeonStorageFirebaseApp app,
        @NonNull String host,
        @NonNull Long port,
        @NonNull Result<Void> result);

    void referenceDelete(
        @NonNull PigeonStorageFirebaseApp app,
        @NonNull PigeonStorageReference reference,
        @NonNull Result<Void> result);

    void referenceGetDownloadURL(
        @NonNull PigeonStorageFirebaseApp app,
        @NonNull PigeonStorageReference reference,
        @NonNull Result<String> result);

    void referenceGetMetaData(
        @NonNull PigeonStorageFirebaseApp app,
        @NonNull PigeonStorageReference reference,
        @NonNull Result<PigeonFullMetaData> result);

    void referenceList(
        @NonNull PigeonStorageFirebaseApp app,
        @NonNull PigeonStorageReference reference,
        @NonNull PigeonListOptions options,
        @NonNull Result<PigeonListResult> result);

    void referenceListAll(
        @NonNull PigeonStorageFirebaseApp app,
        @NonNull PigeonStorageReference reference,
        @NonNull Result<PigeonListResult> result);

    void referenceGetData(
        @NonNull PigeonStorageFirebaseApp app,
        @NonNull PigeonStorageReference reference,
        @NonNull Long maxSize,
        @NonNull Result<byte[]> result);

    void referencePutData(
        @NonNull PigeonStorageFirebaseApp app,
        @NonNull PigeonStorageReference reference,
        @NonNull byte[] data,
        @NonNull PigeonSettableMetadata settableMetaData,
        @NonNull Long handle,
        @NonNull Result<String> result);

    void referencePutString(
        @NonNull PigeonStorageFirebaseApp app,
        @NonNull PigeonStorageReference reference,
        @NonNull String data,
        @NonNull Long format,
        @NonNull PigeonSettableMetadata settableMetaData,
        @NonNull Long handle,
        @NonNull Result<String> result);

    void referencePutFile(
        @NonNull PigeonStorageFirebaseApp app,
        @NonNull PigeonStorageReference reference,
        @NonNull String filePath,
        @NonNull PigeonSettableMetadata settableMetaData,
        @NonNull Long handle,
        @NonNull Result<String> result);

    void referenceDownloadFile(
        @NonNull PigeonStorageFirebaseApp app,
        @NonNull PigeonStorageReference reference,
        @NonNull String filePath,
        @NonNull Long handle,
        @NonNull Result<String> result);

    void referenceUpdateMetadata(
        @NonNull PigeonStorageFirebaseApp app,
        @NonNull PigeonStorageReference reference,
        @NonNull PigeonSettableMetadata metadata,
        @NonNull Result<PigeonFullMetaData> result);

    void taskPause(
        @NonNull PigeonStorageFirebaseApp app,
        @NonNull Long handle,
        @NonNull Result<Map<String, Object>> result);

    void taskResume(
        @NonNull PigeonStorageFirebaseApp app,
        @NonNull Long handle,
        @NonNull Result<Map<String, Object>> result);

    void taskCancel(
        @NonNull PigeonStorageFirebaseApp app,
        @NonNull Long handle,
        @NonNull Result<Map<String, Object>> result);

    /** The codec used by FirebaseStorageHostApi. */
    static @NonNull MessageCodec<Object> getCodec() {
      return FirebaseStorageHostApiCodec.INSTANCE;
    }
    /**
     * Sets up an instance of `FirebaseStorageHostApi` to handle messages through the
     * `binaryMessenger`.
     */
    static void setup(
        @NonNull BinaryMessenger binaryMessenger, @Nullable FirebaseStorageHostApi api) {
      {
        BasicMessageChannel<Object> channel =
            new BasicMessageChannel<>(
                binaryMessenger,
                "dev.flutter.pigeon.firebase_storage_platform_interface.FirebaseStorageHostApi.getReferencebyPath",
                getCodec());
        if (api != null) {
          channel.setMessageHandler(
              (message, reply) -> {
                ArrayList<Object> wrapped = new ArrayList<Object>();
                ArrayList<Object> args = (ArrayList<Object>) message;
                PigeonStorageFirebaseApp appArg = (PigeonStorageFirebaseApp) args.get(0);
                String pathArg = (String) args.get(1);
                String bucketArg = (String) args.get(2);
                Result<PigeonStorageReference> resultCallback =
                    new Result<PigeonStorageReference>() {
                      public void success(PigeonStorageReference result) {
                        wrapped.add(0, result);
                        reply.reply(wrapped);
                      }

                      public void error(Throwable error) {
                        ArrayList<Object> wrappedError = wrapError(error);
                        reply.reply(wrappedError);
                      }
                    };

                api.getReferencebyPath(appArg, pathArg, bucketArg, resultCallback);
              });
        } else {
          channel.setMessageHandler(null);
        }
      }
      {
        BasicMessageChannel<Object> channel =
            new BasicMessageChannel<>(
                binaryMessenger,
                "dev.flutter.pigeon.firebase_storage_platform_interface.FirebaseStorageHostApi.setMaxOperationRetryTime",
                getCodec());
        if (api != null) {
          channel.setMessageHandler(
              (message, reply) -> {
                ArrayList<Object> wrapped = new ArrayList<Object>();
                ArrayList<Object> args = (ArrayList<Object>) message;
                PigeonStorageFirebaseApp appArg = (PigeonStorageFirebaseApp) args.get(0);
                Number timeArg = (Number) args.get(1);
                Result<Void> resultCallback =
                    new Result<Void>() {
                      public void success(Void result) {
                        wrapped.add(0, null);
                        reply.reply(wrapped);
                      }

                      public void error(Throwable error) {
                        ArrayList<Object> wrappedError = wrapError(error);
                        reply.reply(wrappedError);
                      }
                    };

                api.setMaxOperationRetryTime(
                    appArg, (timeArg == null) ? null : timeArg.longValue(), resultCallback);
              });
        } else {
          channel.setMessageHandler(null);
        }
      }
      {
        BasicMessageChannel<Object> channel =
            new BasicMessageChannel<>(
                binaryMessenger,
                "dev.flutter.pigeon.firebase_storage_platform_interface.FirebaseStorageHostApi.setMaxUploadRetryTime",
                getCodec());
        if (api != null) {
          channel.setMessageHandler(
              (message, reply) -> {
                ArrayList<Object> wrapped = new ArrayList<Object>();
                ArrayList<Object> args = (ArrayList<Object>) message;
                PigeonStorageFirebaseApp appArg = (PigeonStorageFirebaseApp) args.get(0);
                Number timeArg = (Number) args.get(1);
                Result<Void> resultCallback =
                    new Result<Void>() {
                      public void success(Void result) {
                        wrapped.add(0, null);
                        reply.reply(wrapped);
                      }

                      public void error(Throwable error) {
                        ArrayList<Object> wrappedError = wrapError(error);
                        reply.reply(wrappedError);
                      }
                    };

                api.setMaxUploadRetryTime(
                    appArg, (timeArg == null) ? null : timeArg.longValue(), resultCallback);
              });
        } else {
          channel.setMessageHandler(null);
        }
      }
      {
        BasicMessageChannel<Object> channel =
            new BasicMessageChannel<>(
                binaryMessenger,
                "dev.flutter.pigeon.firebase_storage_platform_interface.FirebaseStorageHostApi.setMaxDownloadRetryTime",
                getCodec());
        if (api != null) {
          channel.setMessageHandler(
              (message, reply) -> {
                ArrayList<Object> wrapped = new ArrayList<Object>();
                ArrayList<Object> args = (ArrayList<Object>) message;
                PigeonStorageFirebaseApp appArg = (PigeonStorageFirebaseApp) args.get(0);
                Number timeArg = (Number) args.get(1);
                Result<Void> resultCallback =
                    new Result<Void>() {
                      public void success(Void result) {
                        wrapped.add(0, null);
                        reply.reply(wrapped);
                      }

                      public void error(Throwable error) {
                        ArrayList<Object> wrappedError = wrapError(error);
                        reply.reply(wrappedError);
                      }
                    };

                api.setMaxDownloadRetryTime(
                    appArg, (timeArg == null) ? null : timeArg.longValue(), resultCallback);
              });
        } else {
          channel.setMessageHandler(null);
        }
      }
      {
        BasicMessageChannel<Object> channel =
            new BasicMessageChannel<>(
                binaryMessenger,
                "dev.flutter.pigeon.firebase_storage_platform_interface.FirebaseStorageHostApi.useStorageEmulator",
                getCodec());
        if (api != null) {
          channel.setMessageHandler(
              (message, reply) -> {
                ArrayList<Object> wrapped = new ArrayList<Object>();
                ArrayList<Object> args = (ArrayList<Object>) message;
                PigeonStorageFirebaseApp appArg = (PigeonStorageFirebaseApp) args.get(0);
                String hostArg = (String) args.get(1);
                Number portArg = (Number) args.get(2);
                Result<Void> resultCallback =
                    new Result<Void>() {
                      public void success(Void result) {
                        wrapped.add(0, null);
                        reply.reply(wrapped);
                      }

                      public void error(Throwable error) {
                        ArrayList<Object> wrappedError = wrapError(error);
                        reply.reply(wrappedError);
                      }
                    };

                api.useStorageEmulator(
                    appArg,
                    hostArg,
                    (portArg == null) ? null : portArg.longValue(),
                    resultCallback);
              });
        } else {
          channel.setMessageHandler(null);
        }
      }
      {
        BasicMessageChannel<Object> channel =
            new BasicMessageChannel<>(
                binaryMessenger,
                "dev.flutter.pigeon.firebase_storage_platform_interface.FirebaseStorageHostApi.referenceDelete",
                getCodec());
        if (api != null) {
          channel.setMessageHandler(
              (message, reply) -> {
                ArrayList<Object> wrapped = new ArrayList<Object>();
                ArrayList<Object> args = (ArrayList<Object>) message;
                PigeonStorageFirebaseApp appArg = (PigeonStorageFirebaseApp) args.get(0);
                PigeonStorageReference referenceArg = (PigeonStorageReference) args.get(1);
                Result<Void> resultCallback =
                    new Result<Void>() {
                      public void success(Void result) {
                        wrapped.add(0, null);
                        reply.reply(wrapped);
                      }

                      public void error(Throwable error) {
                        ArrayList<Object> wrappedError = wrapError(error);
                        reply.reply(wrappedError);
                      }
                    };

                api.referenceDelete(appArg, referenceArg, resultCallback);
              });
        } else {
          channel.setMessageHandler(null);
        }
      }
      {
        BasicMessageChannel<Object> channel =
            new BasicMessageChannel<>(
                binaryMessenger,
                "dev.flutter.pigeon.firebase_storage_platform_interface.FirebaseStorageHostApi.referenceGetDownloadURL",
                getCodec());
        if (api != null) {
          channel.setMessageHandler(
              (message, reply) -> {
                ArrayList<Object> wrapped = new ArrayList<Object>();
                ArrayList<Object> args = (ArrayList<Object>) message;
                PigeonStorageFirebaseApp appArg = (PigeonStorageFirebaseApp) args.get(0);
                PigeonStorageReference referenceArg = (PigeonStorageReference) args.get(1);
                Result<String> resultCallback =
                    new Result<String>() {
                      public void success(String result) {
                        wrapped.add(0, result);
                        reply.reply(wrapped);
                      }

                      public void error(Throwable error) {
                        ArrayList<Object> wrappedError = wrapError(error);
                        reply.reply(wrappedError);
                      }
                    };

                api.referenceGetDownloadURL(appArg, referenceArg, resultCallback);
              });
        } else {
          channel.setMessageHandler(null);
        }
      }
      {
        BasicMessageChannel<Object> channel =
            new BasicMessageChannel<>(
                binaryMessenger,
                "dev.flutter.pigeon.firebase_storage_platform_interface.FirebaseStorageHostApi.referenceGetMetaData",
                getCodec());
        if (api != null) {
          channel.setMessageHandler(
              (message, reply) -> {
                ArrayList<Object> wrapped = new ArrayList<Object>();
                ArrayList<Object> args = (ArrayList<Object>) message;
                PigeonStorageFirebaseApp appArg = (PigeonStorageFirebaseApp) args.get(0);
                PigeonStorageReference referenceArg = (PigeonStorageReference) args.get(1);
                Result<PigeonFullMetaData> resultCallback =
                    new Result<PigeonFullMetaData>() {
                      public void success(PigeonFullMetaData result) {
                        wrapped.add(0, result);
                        reply.reply(wrapped);
                      }

                      public void error(Throwable error) {
                        ArrayList<Object> wrappedError = wrapError(error);
                        reply.reply(wrappedError);
                      }
                    };

                api.referenceGetMetaData(appArg, referenceArg, resultCallback);
              });
        } else {
          channel.setMessageHandler(null);
        }
      }
      {
        BasicMessageChannel<Object> channel =
            new BasicMessageChannel<>(
                binaryMessenger,
                "dev.flutter.pigeon.firebase_storage_platform_interface.FirebaseStorageHostApi.referenceList",
                getCodec());
        if (api != null) {
          channel.setMessageHandler(
              (message, reply) -> {
                ArrayList<Object> wrapped = new ArrayList<Object>();
                ArrayList<Object> args = (ArrayList<Object>) message;
                PigeonStorageFirebaseApp appArg = (PigeonStorageFirebaseApp) args.get(0);
                PigeonStorageReference referenceArg = (PigeonStorageReference) args.get(1);
                PigeonListOptions optionsArg = (PigeonListOptions) args.get(2);
                Result<PigeonListResult> resultCallback =
                    new Result<PigeonListResult>() {
                      public void success(PigeonListResult result) {
                        wrapped.add(0, result);
                        reply.reply(wrapped);
                      }

                      public void error(Throwable error) {
                        ArrayList<Object> wrappedError = wrapError(error);
                        reply.reply(wrappedError);
                      }
                    };

                api.referenceList(appArg, referenceArg, optionsArg, resultCallback);
              });
        } else {
          channel.setMessageHandler(null);
        }
      }
      {
        BasicMessageChannel<Object> channel =
            new BasicMessageChannel<>(
                binaryMessenger,
                "dev.flutter.pigeon.firebase_storage_platform_interface.FirebaseStorageHostApi.referenceListAll",
                getCodec());
        if (api != null) {
          channel.setMessageHandler(
              (message, reply) -> {
                ArrayList<Object> wrapped = new ArrayList<Object>();
                ArrayList<Object> args = (ArrayList<Object>) message;
                PigeonStorageFirebaseApp appArg = (PigeonStorageFirebaseApp) args.get(0);
                PigeonStorageReference referenceArg = (PigeonStorageReference) args.get(1);
                Result<PigeonListResult> resultCallback =
                    new Result<PigeonListResult>() {
                      public void success(PigeonListResult result) {
                        wrapped.add(0, result);
                        reply.reply(wrapped);
                      }

                      public void error(Throwable error) {
                        ArrayList<Object> wrappedError = wrapError(error);
                        reply.reply(wrappedError);
                      }
                    };

                api.referenceListAll(appArg, referenceArg, resultCallback);
              });
        } else {
          channel.setMessageHandler(null);
        }
      }
      {
        BasicMessageChannel<Object> channel =
            new BasicMessageChannel<>(
                binaryMessenger,
                "dev.flutter.pigeon.firebase_storage_platform_interface.FirebaseStorageHostApi.referenceGetData",
                getCodec());
        if (api != null) {
          channel.setMessageHandler(
              (message, reply) -> {
                ArrayList<Object> wrapped = new ArrayList<Object>();
                ArrayList<Object> args = (ArrayList<Object>) message;
                PigeonStorageFirebaseApp appArg = (PigeonStorageFirebaseApp) args.get(0);
                PigeonStorageReference referenceArg = (PigeonStorageReference) args.get(1);
                Number maxSizeArg = (Number) args.get(2);
                Result<byte[]> resultCallback =
                    new Result<byte[]>() {
                      public void success(byte[] result) {
                        wrapped.add(0, result);
                        reply.reply(wrapped);
                      }

                      public void error(Throwable error) {
                        ArrayList<Object> wrappedError = wrapError(error);
                        reply.reply(wrappedError);
                      }
                    };

                api.referenceGetData(
                    appArg,
                    referenceArg,
                    (maxSizeArg == null) ? null : maxSizeArg.longValue(),
                    resultCallback);
              });
        } else {
          channel.setMessageHandler(null);
        }
      }
      {
        BasicMessageChannel<Object> channel =
            new BasicMessageChannel<>(
                binaryMessenger,
                "dev.flutter.pigeon.firebase_storage_platform_interface.FirebaseStorageHostApi.referencePutData",
                getCodec());
        if (api != null) {
          channel.setMessageHandler(
              (message, reply) -> {
                ArrayList<Object> wrapped = new ArrayList<Object>();
                ArrayList<Object> args = (ArrayList<Object>) message;
                PigeonStorageFirebaseApp appArg = (PigeonStorageFirebaseApp) args.get(0);
                PigeonStorageReference referenceArg = (PigeonStorageReference) args.get(1);
                byte[] dataArg = (byte[]) args.get(2);
                PigeonSettableMetadata settableMetaDataArg = (PigeonSettableMetadata) args.get(3);
                Number handleArg = (Number) args.get(4);
                Result<String> resultCallback =
                    new Result<String>() {
                      public void success(String result) {
                        wrapped.add(0, result);
                        reply.reply(wrapped);
                      }

                      public void error(Throwable error) {
                        ArrayList<Object> wrappedError = wrapError(error);
                        reply.reply(wrappedError);
                      }
                    };

                api.referencePutData(
                    appArg,
                    referenceArg,
                    dataArg,
                    settableMetaDataArg,
                    (handleArg == null) ? null : handleArg.longValue(),
                    resultCallback);
              });
        } else {
          channel.setMessageHandler(null);
        }
      }
      {
        BasicMessageChannel<Object> channel =
            new BasicMessageChannel<>(
                binaryMessenger,
                "dev.flutter.pigeon.firebase_storage_platform_interface.FirebaseStorageHostApi.referencePutString",
                getCodec());
        if (api != null) {
          channel.setMessageHandler(
              (message, reply) -> {
                ArrayList<Object> wrapped = new ArrayList<Object>();
                ArrayList<Object> args = (ArrayList<Object>) message;
                PigeonStorageFirebaseApp appArg = (PigeonStorageFirebaseApp) args.get(0);
                PigeonStorageReference referenceArg = (PigeonStorageReference) args.get(1);
                String dataArg = (String) args.get(2);
                Number formatArg = (Number) args.get(3);
                PigeonSettableMetadata settableMetaDataArg = (PigeonSettableMetadata) args.get(4);
                Number handleArg = (Number) args.get(5);
                Result<String> resultCallback =
                    new Result<String>() {
                      public void success(String result) {
                        wrapped.add(0, result);
                        reply.reply(wrapped);
                      }

                      public void error(Throwable error) {
                        ArrayList<Object> wrappedError = wrapError(error);
                        reply.reply(wrappedError);
                      }
                    };

                api.referencePutString(
                    appArg,
                    referenceArg,
                    dataArg,
                    (formatArg == null) ? null : formatArg.longValue(),
                    settableMetaDataArg,
                    (handleArg == null) ? null : handleArg.longValue(),
                    resultCallback);
              });
        } else {
          channel.setMessageHandler(null);
        }
      }
      {
        BasicMessageChannel<Object> channel =
            new BasicMessageChannel<>(
                binaryMessenger,
                "dev.flutter.pigeon.firebase_storage_platform_interface.FirebaseStorageHostApi.referencePutFile",
                getCodec());
        if (api != null) {
          channel.setMessageHandler(
              (message, reply) -> {
                ArrayList<Object> wrapped = new ArrayList<Object>();
                ArrayList<Object> args = (ArrayList<Object>) message;
                PigeonStorageFirebaseApp appArg = (PigeonStorageFirebaseApp) args.get(0);
                PigeonStorageReference referenceArg = (PigeonStorageReference) args.get(1);
                String filePathArg = (String) args.get(2);
                PigeonSettableMetadata settableMetaDataArg = (PigeonSettableMetadata) args.get(3);
                Number handleArg = (Number) args.get(4);
                Result<String> resultCallback =
                    new Result<String>() {
                      public void success(String result) {
                        wrapped.add(0, result);
                        reply.reply(wrapped);
                      }

                      public void error(Throwable error) {
                        ArrayList<Object> wrappedError = wrapError(error);
                        reply.reply(wrappedError);
                      }
                    };

                api.referencePutFile(
                    appArg,
                    referenceArg,
                    filePathArg,
                    settableMetaDataArg,
                    (handleArg == null) ? null : handleArg.longValue(),
                    resultCallback);
              });
        } else {
          channel.setMessageHandler(null);
        }
      }
      {
        BasicMessageChannel<Object> channel =
            new BasicMessageChannel<>(
                binaryMessenger,
                "dev.flutter.pigeon.firebase_storage_platform_interface.FirebaseStorageHostApi.referenceDownloadFile",
                getCodec());
        if (api != null) {
          channel.setMessageHandler(
              (message, reply) -> {
                ArrayList<Object> wrapped = new ArrayList<Object>();
                ArrayList<Object> args = (ArrayList<Object>) message;
                PigeonStorageFirebaseApp appArg = (PigeonStorageFirebaseApp) args.get(0);
                PigeonStorageReference referenceArg = (PigeonStorageReference) args.get(1);
                String filePathArg = (String) args.get(2);
                Number handleArg = (Number) args.get(3);
                Result<String> resultCallback =
                    new Result<String>() {
                      public void success(String result) {
                        wrapped.add(0, result);
                        reply.reply(wrapped);
                      }

                      public void error(Throwable error) {
                        ArrayList<Object> wrappedError = wrapError(error);
                        reply.reply(wrappedError);
                      }
                    };

                api.referenceDownloadFile(
                    appArg,
                    referenceArg,
                    filePathArg,
                    (handleArg == null) ? null : handleArg.longValue(),
                    resultCallback);
              });
        } else {
          channel.setMessageHandler(null);
        }
      }
      {
        BasicMessageChannel<Object> channel =
            new BasicMessageChannel<>(
                binaryMessenger,
                "dev.flutter.pigeon.firebase_storage_platform_interface.FirebaseStorageHostApi.referenceUpdateMetadata",
                getCodec());
        if (api != null) {
          channel.setMessageHandler(
              (message, reply) -> {
                ArrayList<Object> wrapped = new ArrayList<Object>();
                ArrayList<Object> args = (ArrayList<Object>) message;
                PigeonStorageFirebaseApp appArg = (PigeonStorageFirebaseApp) args.get(0);
                PigeonStorageReference referenceArg = (PigeonStorageReference) args.get(1);
                PigeonSettableMetadata metadataArg = (PigeonSettableMetadata) args.get(2);
                Result<PigeonFullMetaData> resultCallback =
                    new Result<PigeonFullMetaData>() {
                      public void success(PigeonFullMetaData result) {
                        wrapped.add(0, result);
                        reply.reply(wrapped);
                      }

                      public void error(Throwable error) {
                        ArrayList<Object> wrappedError = wrapError(error);
                        reply.reply(wrappedError);
                      }
                    };

                api.referenceUpdateMetadata(appArg, referenceArg, metadataArg, resultCallback);
              });
        } else {
          channel.setMessageHandler(null);
        }
      }
      {
        BasicMessageChannel<Object> channel =
            new BasicMessageChannel<>(
                binaryMessenger,
                "dev.flutter.pigeon.firebase_storage_platform_interface.FirebaseStorageHostApi.taskPause",
                getCodec());
        if (api != null) {
          channel.setMessageHandler(
              (message, reply) -> {
                ArrayList<Object> wrapped = new ArrayList<Object>();
                ArrayList<Object> args = (ArrayList<Object>) message;
                PigeonStorageFirebaseApp appArg = (PigeonStorageFirebaseApp) args.get(0);
                Number handleArg = (Number) args.get(1);
                Result<Map<String, Object>> resultCallback =
                    new Result<Map<String, Object>>() {
                      public void success(Map<String, Object> result) {
                        wrapped.add(0, result);
                        reply.reply(wrapped);
                      }

                      public void error(Throwable error) {
                        ArrayList<Object> wrappedError = wrapError(error);
                        reply.reply(wrappedError);
                      }
                    };

                api.taskPause(
                    appArg, (handleArg == null) ? null : handleArg.longValue(), resultCallback);
              });
        } else {
          channel.setMessageHandler(null);
        }
      }
      {
        BasicMessageChannel<Object> channel =
            new BasicMessageChannel<>(
                binaryMessenger,
                "dev.flutter.pigeon.firebase_storage_platform_interface.FirebaseStorageHostApi.taskResume",
                getCodec());
        if (api != null) {
          channel.setMessageHandler(
              (message, reply) -> {
                ArrayList<Object> wrapped = new ArrayList<Object>();
                ArrayList<Object> args = (ArrayList<Object>) message;
                PigeonStorageFirebaseApp appArg = (PigeonStorageFirebaseApp) args.get(0);
                Number handleArg = (Number) args.get(1);
                Result<Map<String, Object>> resultCallback =
                    new Result<Map<String, Object>>() {
                      public void success(Map<String, Object> result) {
                        wrapped.add(0, result);
                        reply.reply(wrapped);
                      }

                      public void error(Throwable error) {
                        ArrayList<Object> wrappedError = wrapError(error);
                        reply.reply(wrappedError);
                      }
                    };

                api.taskResume(
                    appArg, (handleArg == null) ? null : handleArg.longValue(), resultCallback);
              });
        } else {
          channel.setMessageHandler(null);
        }
      }
      {
        BasicMessageChannel<Object> channel =
            new BasicMessageChannel<>(
                binaryMessenger,
                "dev.flutter.pigeon.firebase_storage_platform_interface.FirebaseStorageHostApi.taskCancel",
                getCodec());
        if (api != null) {
          channel.setMessageHandler(
              (message, reply) -> {
                ArrayList<Object> wrapped = new ArrayList<Object>();
                ArrayList<Object> args = (ArrayList<Object>) message;
                PigeonStorageFirebaseApp appArg = (PigeonStorageFirebaseApp) args.get(0);
                Number handleArg = (Number) args.get(1);
                Result<Map<String, Object>> resultCallback =
                    new Result<Map<String, Object>>() {
                      public void success(Map<String, Object> result) {
                        wrapped.add(0, result);
                        reply.reply(wrapped);
                      }

                      public void error(Throwable error) {
                        ArrayList<Object> wrappedError = wrapError(error);
                        reply.reply(wrappedError);
                      }
                    };

                api.taskCancel(
                    appArg, (handleArg == null) ? null : handleArg.longValue(), resultCallback);
              });
        } else {
          channel.setMessageHandler(null);
        }
      }
    }
  }
}
